# -*- encoding: utf-8 -*-

from django.http import HttpResponse, HttpResponseForbidden
from django.template import Context, Template

from django.utils import simplejson
import pkg_resources
import settings

def json_response(data):
    return HttpResponse(
        simplejson.dumps(data, indent=4),
        content_type = 'application/javascript; charset=utf8'
        )

def versions(request, ):
    valid_token = getattr(settings, 'VERSIONS_TOKEN', None)
    if valid_token is None:
        raise Exception("You have to setup VERSIONS_TOKEN in settings.py")

    if not request.POST.has_key("token"):
        return HttpResponseForbidden("Token needed")
    
    if request.POST['token'] != valid_token:
        return HttpResponseForbidden("Invalid Token")

    versions = {}
    distros = pkg_resources.AvailableDistributions()
    for package_name in distros:
        versions[package_name] = []
        for distro in distros[package_name]:
            versions[package_name].append(distro.version)
    return json_response(versions)

